import RPi.GPIO as IO
import time

# Dieses Script berechnet die Frequenzen fuer 100 Halbtoene und gibt sie nacheinander per PWM auf einem Buzzer aus
# Hier ist es sehr wichtig zu beachten, dass Fliesskommazahlen verwendet werden, da bei der Frequenzberechnung
# zum falschen Zeitpunkt gerundet wird, was zu falschen toenen fuehrt.


IO.setmode(IO.BOARD)    # Nummerierung der Pin
IO.setwarnings(False)
IO.setup(12,IO.OUT)
p = IO.PWM(12,100)                  # Es ist egal, welche Frequenz hier gewaehlt wird, da diese fuer die Tonausgabe eh geaendert wird.
p.start(0)
for x in range(100):                # 100mal die Schleife durchlaufen
    ton=(49.0+x)                    # Bei Ton 49 beginnen (Kammerton A)
    freq=(2**((ton-49.0)/12.0))*440 # Berechnung der Frequenz eines Tons
    p.ChangeFrequency(freq)         # Frequenz fuer PWM einstellen
    p.ChangeDutyCycle(1)           # Ton mit Duty Level 50% aktivieren
    time.sleep(0.1)                 # Ton 0.1s eingeschaltet lassen
    p.ChangeDutyCycle(0)            # Ton abschalten
    time.sleep(0.01)                # 0.01s auf den naechsten Ton warten
