import RPi.GPIO as IO
import time

# Schließen Sie eine RGB-LED mit "Common Ground" So an, dass
# der Minus-Pol der LED mit einem GND-Pin des Raspi verbunden ist
# Der Pin fuer die Rote Farbe wird via Vorwiderstand (300R) mit Pin35 verbunden
# Der Pin fuer die Gruene Farbe wird via Vorwiderstand (300R) mit Pin33 verbunden
# Der Pin fuer die Blaue Farbe wird via Vorwiderstand (300R) mit Pin32 verbunden

IO.setmode (IO.BCM)

IO.setup(19,IO.OUT)   # GPIO19 (PIN35)
IO.setup(13,IO.OUT)   # GPIO13 (PIN33)
IO.setup(12,IO.OUT)   # GPIO12 (PIN32)

r = IO.PWM(19,100)    # GPIO19 "r"
g = IO.PWM(13,100)    # GPIO13 "g"
b = IO.PWM(12,100)    # GPIO19 "b"

r.start(0)            # PWM r starten
g.start(0)            # PWM g starten
b.start(0)            # PWM b starten

# Alle Farben beginnen ausgeschaltet

while 1:
    for x in range (100):
        r.ChangeDutyCycle(x)     # Rot heller
        time.sleep(0.02)
    # Die LED leuchtet nach der ersten Subschleife rot    
    for x in range (100):
        g.ChangeDutyCycle(x)     # Gruen heller
        time.sleep(0.02)
    # Die LED leuchtet nach der zweiten Subschleife gelb
    for x in range (100):
        b.ChangeDutyCycle(x)     # Blau heller
        time.sleep(0.02)

    # Nach der dritten Subschleife sind alle Farb-Komponenten zu 100% an, und die RGB-LED erscheint weiß
        
    for x in range (100):
        r.ChangeDutyCycle(100-x) # Rot dunkler
        time.sleep(0.02)
    # Die LED leuchtet nach der vierten Subschleife tuerkis
    for x in range (100):
        g.ChangeDutyCycle(100-x) # Gruen dunkler
        time.sleep(0.02)
    # Die LED leuchtet nach der ersten Subschleife Blau
    for x in range (100):
        b.ChangeDutyCycle(100-x) # Blau dunkler
        time.sleep(0.02)
    # Der Farbzyklus ist abgeschlossen, die LED ist nun aus, und der Zyklus kann von vorn beginnen.
