#!/usr/bin/python

import sys, time

SPEED = 0.04

import RPi.GPIO as GPIO
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)


# Nebeneinander liegende GPIOs:
# DATA   = 22 # DS
# LATCH  = 27 # STCP
# CLOCK  = 17 # SHCP

# Die Pins von SPI0 nutzend, aber noch als GPIO benutzt:
DATA    = 10 # SPI0_MOSI
LATCH   = 8  # SPI0 CS0
CLOCK   = 11 # SPI0 CLK

def setup():
	GPIO.setmode(GPIO.BCM)
	GPIO.cleanup()
	GPIO.setup(DATA,  GPIO.OUT)
	GPIO.setup(CLOCK, GPIO.OUT)
	GPIO.setup(LATCH, GPIO.OUT)
	GPIO.output(DATA,  False)  # Databit to be shifted into the register
	GPIO.output(LATCH, False)  # Latch is used to output the saved data
	GPIO.output(CLOCK, False)  # Used to shift the value of DATAIN to the register

def shift(dat):
	GPIO.output(DATA,  dat)
	GPIO.output(CLOCK, GPIO.HIGH)
	GPIO.output(CLOCK, GPIO.LOW)

def writeout():
	GPIO.output(LATCH, GPIO.HIGH)
	# time.sleep(icsleep)
	GPIO.output(LATCH, GPIO.LOW)

def shiftnum(dat):
	for i in range(8):
		shift(dat & 0x80 != 0)
		dat <<= 1
	writeout()

setup()

def run_down():
	n = 0x01
	while n < 0x100:
		shiftnum(n)
		time.sleep(SPEED)
		n <<= 1

def run_up():
	n = 0x80
	while n:
		shiftnum(n)
		time.sleep(SPEED)
		n >>= 1

def run_pattern(pattern, speed=0.08):
	for n in pattern:
		shiftnum(n)
		time.sleep(speed)

try:
	while True:
		run_down()
		run_up()
		# run_pattern((
		# 	0x80 | 0x04,
		# 	0x40 | 0x08,
		# 	0x20 | 0x10,
		# 	0x10 | 0x20,
		# 	0x08 | 0x40,
		# 	0x04 | 0x80,
		# 	0x02 | 0x01,
		# 	0x01 | 0x02))

except KeyboardInterrupt:
	print
